clc
clear all
close all
%% Plot settings
params.building="SML5";
params.mode=3;
magn=7.5;
cycles=1;
resolution=10;


%% Building data
frame.L=-13.50;
frame.B=25.34;
frame.H=30;


%% Sensor data
A1.pos=[frame.B-6.08	 frame.L+4.87      29.70];
A2.pos=[frame.B-18.78	 frame.L+8.61      29.70];
A3.pos=[frame.B-18.78	 frame.L+8.61      26.70];
A4.pos=[frame.B-18.78	 frame.L+8.61      11.70];
A1.label="A1";
A2.label="A2";
A3.label="A3";
A4.label="A4";
%% Mode shape
A1.modes=[
    [ 0.07, 0.81,-0.01];
    [ 0.95,-0.22,-0.03];
    [ 0.39, 1.00,-0.03];
    ];
A2.modes=[
    [ 0.10, 1.00, 0.09];
    [ 1.00, 0.00, 0.01];
    [-0.09,-0.63,-0.06];
    ];
A3.modes=[
    [ 0.07, 0.86, 0.09];
    [ 0.90, 0.01,-0.01];
    [-0.07,-0.55,-0.06];
    ];
A4.modes=[
    [ 0.01, 0.10, 0.01];
    [ 0.11,-0.01, 0.00];
    [-0.01,-0.05,-0.01];
    ];
f=figure(1);
k=0;
while k<cycles*2*pi
    k=k+2*pi/resolution;
    params.magn=magn*sin(k);
    plot_mode(f,params,frame,[A1,A2,A3,A4])
end
params.magn=magn;
plot_mode(f,params,frame,[A1,A2,A3,A4])
exportgraphics(gca,'plots/'+params.building+params.mode+".png",'Resolution',300)
function plot_mode(fig,params,frame,sensors)
    figure(fig)
    hold off
    front_color=[0 0 0];
    back_color =[0.75 0.75 0.75];
    %% Plot building frame
    plot3([0 0],[0 0],[0 frame.H],'-','Color',back_color)
    hold on
    plot3([frame.B frame.B],[0 0],[0 frame.H],'-','Color',front_color)
    plot3([frame.B frame.B],[frame.L frame.L],[0 frame.H],'-','Color',front_color)
    plot3([0 0],[frame.L frame.L],[0 frame.H],'-','Color',front_color)

    plot3([0 frame.B],[0 0],[frame.H frame.H],'-','Color',front_color)
    plot3([0 frame.B],[frame.L frame.L],[frame.H frame.H],'-','Color',front_color)
    plot3([0 0],[0 frame.L],[frame.H frame.H],'-','Color',front_color)
    plot3([frame.B frame.B],[0 frame.L],[frame.H frame.H],'-','Color',front_color)

    plot3([0 frame.B],[0 0],[0 0],'-','Color',back_color)
    plot3([0 frame.B],[frame.L frame.L],[0 0],'-','Color',front_color)
    plot3([0 0],[0 frame.L],[0 0],'-','Color',back_color)
    plot3([frame.B frame.B],[0 frame.L],[0 0],'-','Color',front_color)
    
%% Plot sensors
    %% Plot mode shape
    for i=1:length(sensors)
    endp=[sensors(i).pos(1)+params.magn*sensors(i).modes(params.mode,1),sensors(i).pos(2)+params.magn*sensors(i).modes(params.mode,2),sensors(i).pos(3)+params.magn*sensors(i).modes(params.mode,3)];
    plot3(sensors(i).pos(1),sensors(i).pos(2),sensors(i).pos(3),'bo')
    plot3(endp(1),endp(2),endp(3),'ro')
    plot3([sensors(i).pos(1) endp(1)],[sensors(i).pos(2) endp(2)],[sensors(i).pos(3) endp(3)],'r--')
    text(sensors(i).pos(1),sensors(i).pos(2)-6,sensors(i).pos(3)+1,sensors(i).label)
    end
    
    %% Plot axes
    axis_size=8;
    axis_color=[0.75 0.75 0];
    plot3([0 axis_size],[0 0],[0 0],'-','Color',axis_color)
    plot3([0 0],[0 -axis_size],[0 0],'-','Color',axis_color)
    plot3([0 0],[0 0],[0 axis_size],'-','Color',axis_color)
    text(1.1*axis_size,0,0,'X','Color',axis_color)
    text(0,0,1.1*axis_size,'Y','Color',axis_color)
    text(0,-1.1*axis_size,0,'Z','Color',axis_color)


    
    %% Format plot
    xlim([-0.5*frame.B    1.5*frame.B]);
    ylim([-1.5*frame.B    0.5*frame.B]);
    zlim([0         1.5*frame.H]);
    set(gca,'view',[45 22.5])
    set(gcf, 'Position',  [0, 0, 500, 700])
    set(gca,'visible','off')
    %set(gca,'Color',[0.95,0.95,1])
end