# -*- coding: mbcs -*-
from abaqus import *
from abaqusConstants import *
from part import *
from material import *
from section import *
from assembly import *
from step import *
from interaction import *
from load import *
from mesh import *
from optimization import *
from job import *
from sketch import *
from visualization import *
from connectorBehavior import *
from regionToolset import *
from odbAccess import *
import sys

def create_boundary_condition(
    amplitude=[],
    distributionType=[], 
    current_model=[],
    stepname='Initial',
    setname=[],
    bc_name ='',
    DOFs    =[]
):
    current_model.DisplacementBC(
        amplitude=UNSET, 
        createStepName=stepname, 
        distributionType=UNIFORM, 
        fieldName='', 
        localCsys=None, 
        name=bc_name, 
        region=current_model.rootAssembly.sets[setname], 
        u1=DOFs[0], 
        u2=DOFs[1], 
        u3=DOFs[2], 
        ur1=DOFs[3], 
        ur2=DOFs[4], 
        ur3=DOFs[5]
        )