# -*- coding: mbcs -*-
from abaqus import *
from abaqusConstants import *
from part import *
from material import *
from section import *
from assembly import *
from step import *
from interaction import *
from load import *
from mesh import *
from optimization import *
from job import *
from sketch import *
from visualization import *
from connectorBehavior import *
from regionToolset import *
from odbAccess import *
from sys import *
from UTIL_tools import *
from CONF_config import *
import openpyxl
import unicodedata





def define_material(
    current_model       = [],
    material_data        = [],
):
    if material_data["Type"] == 'Orthotropic':
        define_orthotropic_material(
            current_model       = current_model,
            material_data        = material_data,
            )
    if material_data["Type"] == 'Isotropic':
        define_isotropic_material(
            current_model       = current_model,
            material_data        = material_data
            )

def define_orthotropic_material(
    current_model       = [],
    material_data        = [],
):
    #Create material
    current_model.Material(name=material_data["Name"])
    #Assign elastic properties
    current_model.materials[material_data["Name"]].Elastic(
        table=(
            (
            material_data["E1"], 
            material_data["E2"], 
            material_data["E3"], 
            material_data["Nu12"], 
            material_data["Nu13"], 
            material_data["Nu23"], 
            material_data["G12"], 
            material_data["G13"], 
            material_data["G23"]), 
            ), 
        type=ENGINEERING_CONSTANTS)
    #Assign damping
    current_model.materials[material_data["Name"]].Damping(
        alpha       = material_data["Alpha"], 
        beta        = material_data["Beta"], 
        composite   = material_data["Composite"], 
        structural  = material_data["Structural"]
        )
    current_model.materials[material_data["Name"]].Density(table=((material_data["Density"], ), ))
def define_isotropic_material(
    current_model       = [],
    material_data        = [],
):
    #Create material
    current_model.Material(name=material_data["Name"])
    #Assign elastic properties
    current_model.materials[material_data["Name"]].Elastic(
        table=(
                (
                material_data["E1"], 
                material_data["Nu12"], 
                ),
            ), 
        type=ISOTROPIC
        )

    #Assign damping
    current_model.materials[material_data["Name"]].Damping(
        alpha       = material_data["Alpha"], 
        beta        = material_data["Beta"], 
        composite   = material_data["Composite"], 
        structural  = material_data["Structural"]
        )
    current_model.materials[material_data["Name"]].Density(table=((material_data["Density"], ), ))