from scipy import signal
import numpy as np
import matplotlib.pyplot as plt
font = {'family' : 'normal',
        'weight' : 'normal',
        'size'   : 16}

plt.rc('font', **font)
fo=5
fs=400
co=16

time=1

t = np.linspace(0, time, time*fs, False)  # 1 second
sig = (
    np.sin(2*np.pi*5*t) + 
    np.sin(2*np.pi*30*t)
    )

fig, (ax1, ax2) = plt.subplots(2, 1, sharex=True)
ax1.plot(t, sig)
ax1.set_title('2 Hz and 20 Hz')
ax1.axis([0, 1, -2, 2])

sos = signal.butter(fo, co, 'low', fs=fs, output='sos')
filtered = signal.sosfilt(sos, sig)
ax2.plot(t, filtered)
ax2.set_title('After 16 Hz low-pass filter')
ax2.axis([0, 1, -2, 2])
ax2.set_xlabel('T [s]')
plt.tight_layout()
plt.show()