from scipy.signal import detrend
import matplotlib.pyplot as plt
import numpy as np


freqs=[1,2]
weights=[1,1]
fs  = 400
time= 5
n   = fs*time
t   = np.linspace(0, time, n)
x=0
for freq,weight in zip(freqs,weights):
    x+=np.sin(2*np.pi*t*freq)*(weight)
slope=1
xnoise=x+t*slope

y1       = xnoise
y2       = detrend(xnoise)

font = {'family' : 'DejaVu Sans',
        'weight' : 'normal',
        'size'   : 10}

lw=2.5
plt.rc('font', **font)
plt.plot(t, t*slope, label='Spurious trend',color=[0,0,0],linestyle='dashed',linewidth=lw)
plt.plot(t, y1, label='Original signal',color=[0.1,0.1,1],linestyle='dashed',linewidth=1)
plt.plot(t, y2, label='Detrended signal',color=[1,0.1,0.1],linestyle='solid',linewidth=1)
plt.legend(framealpha=1, shadow=True,loc=1)
plt.xlim=[0,10]
plt.axis('off')
plt.show()